var NAVTREE =
[
  [ "GEIS", "index.html", [
    [ "Modules", "modules.html", [
      [ "Common Types and Definitions", "group__geis__common.html", null ],
      [ "The Simplified GEIS Interface", "group__geis__v1.html", [
        [ "Gesture Types", "group__geis__v1__gesture__types.html", [
          [ "Gesture Primitives", "group__geis__v1__gesture__primitives.html", null ],
          [ "Standard Gesture Types", "group__geis__v1__standar__gesture__types.html", null ],
          [ "Vendor Extension Gesture Types", "group__geis__v1__vendor__extensions.html", null ]
        ] ],
        [ "Initialization and Cleanup", "group__geis__meta.html", null ],
        [ "Configuration and Control", "group__geis__v1__config.html", null ],
        [ "Input Devices", "group__geis__v1__input.html", null ],
        [ "Gesture Subscription", "group__geis__v1__subscription.html", null ]
      ] ],
      [ "The Advanced GEIS Interface", "group__geis__v2.html", [
        [ "The Geis API Object", "group__geis__v2__geis.html", null ],
        [ "Error Reporting", "group__geis__v2__error.html", null ],
        [ "Configuration", "group__geis__v2__config.html", null ],
        [ "Attributes", "group__geis__v2__attrs.html", null ],
        [ "Event Control", "group__geis__v2__event__control.html", null ],
        [ "Input Devices", "group__geis__v2__device.html", null ],
        [ "Gesture Classes", "group__geis__v2__class.html", null ],
        [ "Gesture Regions", "group__geis__v2__region.html", null ],
        [ "Gesture Filter", "group__geis__v2__filter.html", null ],
        [ "Gesture Subscription", "group__geis__v2__subscription.html", null ],
        [ "Gesture Frames", "group__geis__v2__gesture.html", null ]
      ] ]
    ] ],
    [ "Data Structures", "annotated.html", [
      [ "Geis", "class_geis.html", null ],
      [ "GeisDevice", "class_geis_device.html", null ],
      [ "GeisEvent", "class_geis_event.html", null ],
      [ "GeisFilter", "class_geis_filter.html", null ],
      [ "GeisFrame", "class_geis_frame.html", null ],
      [ "GeisGestureAttr", "struct_geis_gesture_attr.html", null ],
      [ "GeisGestureClass", "class_geis_gesture_class.html", null ],
      [ "GeisGestureFuncs", "struct_geis_gesture_funcs.html", null ],
      [ "GeisGroup", "class_geis_group.html", null ],
      [ "GeisGroupSet", "class_geis_group_set.html", null ],
      [ "GeisInputFuncs", "struct_geis_input_funcs.html", null ],
      [ "GeisInstance", "class_geis_instance.html", null ],
      [ "GeisRegion", "class_geis_region.html", null ],
      [ "GeisSubscription", "class_geis_subscription.html", null ],
      [ "GeisTouch", "class_geis_touch.html", null ],
      [ "GeisTouchId", "class_geis_touch_id.html", null ],
      [ "GeisTouchSet", "class_geis_touch_set.html", null ],
      [ "GeisWinInfo", "struct_geis_win_info.html", null ]
    ] ],
    [ "Data Structure Index", "classes.html", null ],
    [ "Data Fields", "functions.html", null ],
    [ "File List", "files.html", [
      [ "/build/buildd/utouch-geis-2.0.10/include/geis/geis.h", "geis_8h.html", null ]
    ] ],
    [ "Globals", "globals.html", null ]
  ] ]
];

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode)
  {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  if (level==0 && node.childrenData)
  {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() 
    {
      if (node.expanded) 
      {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast)
        {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        }
        else
        {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } 
      else 
      {
        expandNode(o, node, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  }
  else
  {
    domNode.appendChild(imgNode);
  }
  if (level==0)
  {
    if (node.isLast)
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    }
    else
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2pnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  }
  else
  {
    if (node.isLast)
    {
      imgNode.src = node.relpath+"ftv2blank.png";
    }
    else
    {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  a.appendChild(node.label);
  if (link) 
  {
    a.href = node.relpath+link;
  } 
  else 
  {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
      node.expanded = false;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() 
  {
    if (!node.childrenUL) 
    {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
}

function expandNode(o, node, imm)
{
  if (node.childrenData && !node.expanded) 
  {
    if (!node.childrenVisited) 
    {
      getNode(o, node);
    }
    if (imm)
    {
      $(node.getChildrenUL()).show();
    } 
    else 
    {
      $(node.getChildrenUL()).slideDown("fast",showRoot);
    }
    if (node.isLast)
    {
      node.plus_img.src = node.relpath+"ftv2mlastnode.png";
    }
    else
    {
      node.plus_img.src = node.relpath+"ftv2mnode.png";
    }
    node.expanded = true;
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) 
  {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
        i==l);
  }
}

function findNavTreePage(url, data)
{
  var nodes = data;
  var result = null;
  for (var i in nodes) 
  {
    var d = nodes[i];
    if (d[1] == url) 
    {
      return new Array(i);
    }
    else if (d[2] != null) // array of children
    {
      result = findNavTreePage(url, d[2]);
      if (result != null) 
      {
        return (new Array(i).concat(result));
      }
    }
  }
  return null;
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;

  getNode(o, o.node);

  o.breadcrumbs = findNavTreePage(toroot, NAVTREE);
  if (o.breadcrumbs == null)
  {
    o.breadcrumbs = findNavTreePage("index.html",NAVTREE);
  }
  if (o.breadcrumbs != null && o.breadcrumbs.length>0)
  {
    var p = o.node;
    for (var i in o.breadcrumbs) 
    {
      var j = o.breadcrumbs[i];
      p = p.children[j];
      expandNode(o,p,true);
    }
    p.itemDiv.className = p.itemDiv.className + " selected";
    p.itemDiv.id = "selected";
    $(window).load(showRoot);
  }
}

